'\"
'\" Copyright (c) 1995 The Regents of the University of California.
'\" Copyright (c) 1995 LAS, Incorporated
'\"
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" @(#) olednd.n 1.00 95/06/25 21:15:08
'\" 

'\" From man.macros
'\" The definitions below are for supplemental macros used in Tcl/Tk
'\" manual entries.
'\"
'\" .AP type name in/out [indent]
'\"	Start paragraph describing an argument to a library procedure.
'\"	type is type of argument (int, etc.), in/out is either "in", "out",
'\"	or "in/out" to describe whether procedure reads or modifies arg,
'\"	and indent is equivalent to second arg of .IP (shouldn't ever be
'\"	needed;  use .AS below instead)
'\"
'\" .AS [type [name]]
'\"	Give maximum sizes of arguments for setting tab stops.  Type and
'\"	name are examples of largest possible arguments that will be passed
'\"	to .AP later.  If args are omitted, default tab stops are used.
'\"
'\" .BS
'\"	Start box enclosure.  From here until next .BE, everything will be
'\"	enclosed in one large box.
'\"
'\" .BE
'\"	End of box enclosure.
'\"
'\" .VS
'\"	Begin vertical sidebar, for use in marking newly-changed parts
'\"	of man pages.
'\"
'\" .VE
'\"	End of vertical sidebar.
'\"
'\" .DS
'\"	Begin an indented unfilled display.
'\"
'\" .DE
'\"	End of indented unfilled display.
'\"
'\" @(#) man.macros 1.3 95/05/06 15:19:04
'\"
'\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp
..

.TH olednd n 1.0 TkNTExt "Extended Tk Commands for NT"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
olednd \- Tcl OLE Drag and Drop Interface
.SH SYNOPSIS
\fBolednd bindtarget\fI windowId\fR
.br
\fBolednd bindtarget\fI windowId type\fR
.br
\fBolednd bindtarget\fI windowId type script ?-priority <1-100>?\fR
.br
\fBolednd cleartarget\fI windowId\fR
.br
\fBolednd bindsource\fI windowId\fR
.br
\fBolednd bindsource\fI windowId type\fR
.br
\fBolednd bindsource\fI windowId type script\fR
.br
\fBolednd clearsource\fI windowId\fR
.br
\fBolednd drag\fI windowId\fR
.br

.SH INTRODUCTION
.PP
The \fBolednd\fR command provides a Tcl interface to the OLE drag and
drop mechanism.  To setup for drag and drop, register the drag/drop types
that can be handled by source and target windows.  When a drag operation
commences, one or more of the types that was registered on the window
must match for a drop to occur.  If no match is found, the cursor shown
is a small circle with a line through it.  If a match is found, the OLE2
cursor indicating a copy or move operation is shown.

.SH "SETTING UP THE TARGET"
.PP
To register a data type that can be handled by a target window, use the
\fBbindtarget\fR option.  For example, to handle plain dropped text, use
\fICF_TEXT\fR as the type.

  \fBolednd bindtarget .tgt CF_TEXT {puts}\fR

When a drop occurs from a source that has data of \fICF_TEXT\fR, the text will
be appended a the last argument to the command.  In this case, if the
dragged data was a sentence such as "The quick brown fox jumped over the
moon", the command that would be run is

  \fBputs "The quick brown fox jumped over the moon"\fR

You can specify anything as a data type.  \fICF_TEXT\fR is a special case that
represents all simple ASCII text that can be dragged and dropped.  Creating
a handler for \fICF_TEXT\fR on a window will allow that window to handle text
drags and drops from another OLE enabled application that also uses the
standard \fICF_TEXT\fR mechanism.

Some other common types for dragging and dropping to and from web browsers
are \fIUniformResourceLocator\fR and \fI"Netscape Bookmark"\fR.  The
type \fIFileName\fR is used by Explorer to drag and drop a file from the
desktop.

You can register more than a single type to be handled by a window.
Just run the command again with a different data type.  Here is another
example for the same window.

  \fBolednd bindtarget .tgt TKNT_COLOR {.tgt config -bg}\fR

In this case, if a an object gets dropped on window .tgt, .tgt will ask the
source if it supports either CF_TEXT or TKNT_COLOR.  If it does, it will
run the script for the match.  It is possible that more than one type 
would be matched between the source and target.  For this case, you can
use the \fB-priority <num>\fR option to specify the order in which you
want the search for matches to occur.  Priorities range from 1 to 100.
1 is the highest priority, 50 is the default priority, and 100 is the
lowest priority.  If two target data types have the same priority, it
is undetermined which one will be checked for first.  In the above 
example, if you want to check for the TKNT_COLOR datatype before CF_TEXT,
give a higher priority to the TKNT_COLOR datatype.

  \fBolednd bindtarget .tgt TKNT_COLOR {.tgt config -bg} -priority 1\fR


.SH "SETTING UP THE DRAG SOURCE"
For sources, register the data types that can be provided by a window
the the \fBbindsource\fR option.  For example, to be registered as a
drop source for ASCII text, use CF_TEXT as the data type.

  \fBolednd bindsource .src CF_TEXT {return "Some text"}\fR

More than one datatype can be registered with a source window.  To go
along with our example, setup the window as a provider of data of type
TKNT_COLOR.

  \fBolednd bindsource .src TKNT_COLOR {return red}\fR

.SH "THE DRAG OPERATION"
Now that both the target window and the source window have been configured,
one as a data source and the other as a drop area, we still need to do
something to initiate the drag operation.  If the application that is
being dragged from is not part of Tk, we let it handle the drag & drop 
operation.  If we want to drag something from \fB.src\fR to \fB.tgt\fR,
we initiate the drag and drop operation with the \fBdrag\fR option.  Here,
we start the operation on a press of mouse button 1.

  \fBbind .src <1> {olednd drag %W}\fR

Once button 1 is pressed on \fB.src\fR, the drag operation begins.
When the button is released, a different button is pressed, or a modifier
key is pressed during the operation, then a drop operation occurs.
If the drop occurs over a window that has a type that matches the source
window, then the script for the source window gets run first.  If you
do not want the source window to send data, it can do a

  \fBreturn -code break\fR

If the return value is not an error or a break code, the target window script
for the matched datatype is then run.

For the example above, the datatype that matched would be TKNT_COLOR.
First, the script for data type TKNT_COLOR on window \fB.src\fR would be run.
This is 

  \fBreturn red\fR

The string "red" would now be appended to the command for datatype TKNT_COLOR
on the target window \fB.tgt\fR.  The command would be

  \fB.tgt config -bg red\fR

In our simple example, \fB.tgt\fR would change its background color to red on
a drag and drop from \fB.src\fR.


.SH "BINDING SCRIPTS AND SUBSTITUTIONS"
.LP
If a \fIscript\fR contains
any \fB%\fR characters, then the script will not be
executed directly.  Instead, a new script will be
generated by replacing each \fB%\fR, and the character following
it, with information from the current drop event.  The replacement
depends on the character following the \fB%\fR, as defined in the
list below.
.TP
\fB%%\fR
Replaced with a single percent.
.TP
\fB%T\fR
The name of the dropped data type.
.TP
\fB%W\fR
The \fIwindow\fR the script was bound to.
.TP
\fB%X\fR
The screen X cursor coordinate when the drop occurred.
.VS
This is undefined for the source script.
.VE
.TP
\fB%Y\fR
The screen Y cursor coordinate when the drop occurred.
.VS
This is undefined for the source script.
.VE
.TP
\fB%x\fR
The window relative X cursor coordinate when the drop occurred.
.VS
This is undefined for the source script.
.VE
.TP
\fB%y\fR
The window relative Y cursor coordinate when the drop occurred.
.VS
This is undefined for the source script.
.VE


.SH "COMMANDS"
\fBolednd bindtarget\fI windowId\fR
.br
Returns a list of drag/drop datatypes that are handled by the window.

\fBolednd bindtarget\fI windowId type\fR
.br
Returns the script that would be invoked if an object of datatype \fItype\fR
were dropped on the window \fIwindowId\fR.

\fBolednd bindtarget\fI windowId type script ?-priority num (1-100)?\fR
.br
Binds a script to run when a dropped object's datatype matches.  If an
empty script is given, \fItype\fR is removed as a handled datatype.

\fBolednd cleartarget\fI windowId\fR
.br
Removes all dropped data handlers from the window.

\fBolednd bindsource\fI windowId\fR
.br
Returns a list of drag/drop datatypes that can be generated by the window.

\fBolednd bindsource\fI windowId type\fR
.br
Returns the script that gets run when a drop operation has occurred and
the target has matched this \fItype\fR.

\fBolednd bindsource\fI windowId type script\fR
.br
Binds a script to run when a drop operation has occurred and the target
has matched this \fItype\fR.

\fBolednd clearsource\fI windowId\fR
.br
Removes all datatypes that could be generated by the window \fIwindowId\fR.

\fBolednd drag\fI windowId\fR
.br
Initiates an OLE drag and drop operation.

.SH NOTES
Only one match is generated for each source/dest.  This means that a 
maximum of one script will be run for source and one for the target.
If an error occurs in the source script, the drop operation fails.

.SH ERRORS
.LP
If an error occurs in executing the script for a binding then the
\fBtkerror\fR mechanism is used to report the error.
.VS
The \fBtkerror\fR command will be executed at global level
(outside the context of any Tcl procedure).
.VE

.SH "SEE ALSO"
tkerror

.SH KEYWORDS
OLE, drag, drop
