/*
 *----------------------------------------------------------------------
 * Filename: tdataobject.h
 *
 *	This file defines the class TDataObject
 *
 *----------------------------------------------------------------------
 */

#ifndef _TDATAOBJECT_H_
#define _TDATAOBJECT_H_

class TDataObject;
typedef class TDataObject *PTDataObject;

class TDataObject: public IDataObject
{
  private:
    int			    m_refCnt; 		/* Reference Count */
    PTCallback		    m_callbacks;
    LPVOID		    m_clientData;	/* Tcl Interpreter */

    /* The clipboard formats that can be handled */
    UINT		    m_numTypes;		/* Number of types in list */
    UINT		    m_maxTypes;		/* # of types that fit */
    FORMATETC *		    m_typeList;		/* List of types */

  public:
    /* Constructor/Destructor */
    TDataObject(PTCallback, LPVOID);
    ~TDataObject(void);

    /* IUnknown methods */
    STDMETHODIMP	    QueryInterface(REFIID, LPVOID *);
    STDMETHODIMP_(ULONG)    AddRef();
    STDMETHODIMP_(ULONG)    Release();


    /* IDataObject methods */
    STDMETHODIMP	    GetData(LPFORMATETC, LPSTGMEDIUM);

    STDMETHODIMP	    GetDataHere(LPFORMATETC, LPSTGMEDIUM);

    STDMETHODIMP	    QueryGetData(LPFORMATETC);

    STDMETHODIMP	    GetCanonicalFormatEtc(LPFORMATETC, LPFORMATETC);

    STDMETHODIMP	    SetData(LPFORMATETC, LPSTGMEDIUM, BOOL);

    STDMETHODIMP	    EnumFormatEtc(DWORD, LPENUMFORMATETC *);

    STDMETHODIMP	    DAdvise(LPFORMATETC, DWORD, LPADVISESINK, DWORD *);

    STDMETHODIMP	    DUnadvise(DWORD);

    STDMETHODIMP	    EnumDAdvise(IEnumSTATDATA **);

    /* Available source data types--not part of the OLE exposed interface */
    STDMETHODIMP	    AddDataType(UINT);
    STDMETHODIMP	    DelDataType(UINT);

};
#endif /* _TDATAOBJECT_H_ */
