/*
 *----------------------------------------------------------------------
 * Filename: idropsource.h
 *
 *	Implements the TDropSource class, an IDropSource interface
 *----------------------------------------------------------------------
 */
#ifndef _TDROPSOURCE_H_
#define _TDROPSOURCE_H_

class TDropSource;
typedef class TDropSource *PTDropSource;

class TDropSource: public IDropSource
{
  private:
    ULONG m_refCnt;		/* Reference count */
    DWORD m_keyState;		/* The initial key state */
    DWORD m_button;		/* Drag continues while this button is down */

  public:
    TDropSource(DWORD, DWORD);
    ~TDropSource(void);

    /* IUnknown members */
    STDMETHODIMP		QueryInterface(REFIID, LPVOID *);
    STDMETHODIMP_(ULONG)	AddRef(void);
    STDMETHODIMP_(ULONG)	Release(void);

    /* IDropSource members */
    STDMETHODIMP		QueryContinueDrag(BOOL, DWORD);
    STDMETHODIMP		GiveFeedback(DWORD);
};


#endif /* _TDROPSOURCE_H_ */
