/*
 *----------------------------------------------------------------------
 * Filename: tdroptarget.h
 *
 *	Implements the TDropTarget class, an IDropTarget interface
 *----------------------------------------------------------------------
 */
#ifndef _TDROPTARGET_H_
#define _TDROPTARGET_H_

class TDropTarget;
typedef class TDropTarget *PTDropTarget;

class TDropTarget: public IDropTarget
{
  protected:
    ULONG			m_refCnt;	/* Reference count */
    PTCallback			m_callbacks;
    LPVOID			m_clientData;	/* User data */
    LPDATAOBJECT		m_pIDataSource; /* This gets set on a DragEnter,
						   cleared on a DragLeave */
    DWORD			m_lastEffect;	/* Set by DragEnter */
    DWORD			m_lastFormat;	/* Set by DragEnter */

  public:
    TDropTarget(PTCallback, LPVOID);
    ~TDropTarget(void);

    /* IUnknown interface members */
    STDMETHODIMP	       QueryInterface(REFIID, LPVOID *);
    STDMETHODIMP_(ULONG)       AddRef(void);
    STDMETHODIMP_(ULONG)       Release(void);

    /* IDropTarget interface members */
    STDMETHODIMP	       DragEnter(LPDATAOBJECT, DWORD, POINTL, LPDWORD);
    STDMETHODIMP	       DragOver(DWORD, POINTL, LPDWORD);
    STDMETHODIMP	       DragLeave(void);
    STDMETHODIMP	       Drop(LPDATAOBJECT, DWORD, POINTL, LPDWORD);

  private:
    STDMETHODIMP	       Callback(LPDATAOBJECT, DWORD, POINTL, LPDWORD,
					char *);
    
};

#endif /* _TDROPTARGET_H_ */
