# Set this so the activeForeground does not make it seem as if the color
# droppping had no effect.

set tk_strictMotif 1

set ole 0
if {[info command olednd] == "olednd"} {
    set ole 1
}

set red 0
set green 0
set blue 0

proc set_red {x} {
    global red green blue
    set red $x
    .red.sample config -bg #[format %02x0000 $red]
    .color.l config -bg #[format %02x%02x%02x $red $green $blue]
}

proc set_green {x} {
    global red green blue
    set green $x
    .green.sample config -bg #[format 00%02x00 $green]
    .color.l config -bg #[format %02x%02x%02x $red $green $blue]
}

proc set_blue {x} {
    global red green blue
    set blue $x
    .blue.sample config -bg #[format 0000%02x $blue]
    .color.l config -bg #[format %02x%02x%02x $red $green $blue]
}

#
# Red slider...
#
frame .red -borderwidth 3 -relief raised
scale .red.cntl -label "Red" -orient horizontal -from 0 -to 255 \
    -command set_red
frame .red.sample -height 20 -width 20 -borderwidth 3 -relief raised
pack .red.cntl -side left -expand yes -fill x
pack .red.sample -side right -fill y

#
# Green slider...
#
frame .green -borderwidth 3 -relief raised
scale .green.cntl -label "Green" -orient horizontal -from 0 -to 255 \
    -command set_green
frame .green.sample -height 20 -width 20 -borderwidth 3 -relief raised
pack .green.cntl -side left -expand yes -fill x
pack .green.sample -side right -fill y

#
# Blue slider...
#
frame .blue -borderwidth 3 -relief raised
scale .blue.cntl -label "Blue" -orient horizontal -from 0 -to 255 \
    -command set_blue
frame .blue.sample -height 20 -width 20 -borderwidth 3 -relief raised
pack .blue.cntl -side left -expand yes -fill x
pack .blue.sample -side right -fill y

#
# Color area
#
frame .color -height 60
pack propagate .color no
label .color.l -bg black -fg White -text "Drag and Drop Source"
pack .color.l -fill both -expand yes

if {$ole} {
    olednd bindsource .color.l TKNT_COLOR {format #%%02x%%02x%%02x $red $green $blue}
    bind .color.l <1> {olednd drag %W}
}

#
# Droppable buttons
#
set f .f
frame $f
if {$ole} {
    foreach i {1 2 3 4 5 6} {
	set b $f.b$i
	button $b -text "Target $i"
	pack $b -side left
	olednd bindtarget $b TKNT_COLOR {%W config -bg }
    }
}

pack .red .blue .green .color .f -fill x -expand yes
